<?php
class HttpProxy {
    private $akId;
    private $akSecret;

    public function __construct($akId, $akSecret) {
        $this->akId = $akId;
        $this->akSecret = $akSecret;
    }

    private function gmt_time() {
        return gmdate("D, d M Y H:i:s \G\M\T");
    }

    private function md5_base64($strbody) {
        return base64_encode(md5($strbody, true));
    }

    private function sha1_base64($strtosign, $secret) {
        return base64_encode(hash_hmac("sha1", $strtosign, $secret, true));
    }

    public function send_request($url, $post_data) {        
        $gmtnow = $this->gmt_time();
       
        $jsonbody = json_encode($post_data);
        $bodymd5 = $this->md5_base64($jsonbody);
        $strtosign = "POST\napplication/json\n" . $bodymd5 . "\napplication/json\n" . $gmtnow;
        $signature = $this->sha1_base64($strtosign, $this->akSecret);
        $auth_header = "Dataplus " . $this->akId . ":" . $signature;

        $header = array('Accept:application/json', 'Content-Type:application/json', 'Date:'.$gmtnow, 'Authorization:'.$auth_header);

        $ch = curl_init();
        if(substr($url, 0, 5) == "https") {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, true);
        }

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonbody);
        $response = curl_exec($ch);
        if($error = curl_error($ch)){
            die($error);
        }
        curl_close($ch);
        return $response;
    }
}
?>